# Tcl based calculation using a foreach command tcl script

proc foreach_instance { var1 record body } {
  set vlen [ $record size ]
  upvar 1 $var1 value
  for { set i 0 } { $i < $vlen } { incr i } {
      set value [$record value $i]
      uplevel 1 $body
  }
}

proc do_calculation { record } {
  set wval 0.0
  set vlen 0
  set old_val 0.0
  foreach_instance value $record {
    set wval [ expr { pow(1.009 + sqrt($old_val)*(1/(abs($wval)+0.001) + $value ), 1.0002) } ]
    set old_val [ expr { $wval/2.355832 } ]
    incr vlen
  }
  return [ expr { $wval/$vlen } ]
};

